// This file is auto-generated, don't edit it. Thanks.
package com.aliyun.sample;

import com.aliyun.tea.*;
import com.aliyun.teaconsole.*;
import com.aliyun.darabonba.env.*;
import com.aliyun.teaopenapi.*;
import com.aliyun.teaopenapi.models.*;
import com.aliyun.ecs20140526.*;
import com.aliyun.ecs20140526.models.*;
import com.aliyun.teautil.*;

public class Sample {

    /**
    * Initialization  初始化公共请求参数
    */
    public static com.aliyun.ecs20140526.Client Initialization(String regionId) throws Exception {
        Config config = new Config()
                .setAccessKeyId(com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_ID"))
                .setAccessKeySecret(com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_SECRET"))
                .setRegionId(regionId);
        return new com.aliyun.ecs20140526.Client(config);
    }

    public static void StopInstance(com.aliyun.ecs20140526.Client client, String instanceId, Boolean forceStop) throws Exception {
        if (com.aliyun.teautil.Common.isUnset(forceStop)) {
            forceStop = false;
        }

        StopInstanceRequest req = new StopInstanceRequest()
                .setInstanceId(instanceId)
                .setForceStop(forceStop);
        client.stopInstance(req);
        com.aliyun.teaconsole.Client.log("Stop " + instanceId + " command submit successfully.");
    }

    public static DescribeInstancesResponse DescribeInstanceDetail(com.aliyun.ecs20140526.Client client, String regionId, String instanceId) throws Exception {
        DescribeInstancesRequest req = new DescribeInstancesRequest()
                .setRegionId(regionId)
                .setInstanceIds(com.aliyun.teautil.Common.toJSONString(java.util.Arrays.asList(
                    instanceId
                )));
        DescribeInstancesResponse resp = client.describeInstances(req);
        return resp;
    }

    public static String CheckAutoReleaseTimeReady(com.aliyun.ecs20140526.Client client, String regionId, String instatnceId) throws Exception {
        DescribeInstancesResponse resp = Sample.DescribeInstanceDetail(client, regionId, instatnceId);
        DescribeInstancesResponseBody.DescribeInstancesResponseBodyInstancesInstance instance = resp.body.instances.instance.get(0);
        if (com.aliyun.teautil.Common.isUnset(TeaModel.buildMap(instance))) {
            return "";
        }

        return instance.autoReleaseTime;
    }

    public static void ReleaseInstance(com.aliyun.ecs20140526.Client client, String regionId, String instanceId, Boolean force) throws Exception {
        DeleteInstancesRequest req = new DeleteInstancesRequest()
                .setRegionId(regionId)
                .setInstanceId(java.util.Arrays.asList(
                    instanceId
                ))
                .setForce(force);
        DeleteInstancesResponse resp = client.deleteInstances(req);
        com.aliyun.teaconsole.Client.log("--------------------实例释放成功--------------------");
        com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(com.aliyun.teautil.Common.toMap(resp)));
    }

    public static void SetInstanceAutoReleaseTime(com.aliyun.ecs20140526.Client client, String regionId, String instanceId, String timeToRelease) throws Exception {
        ModifyInstanceAutoReleaseTimeRequest req = new ModifyInstanceAutoReleaseTimeRequest()
                .setRegionId(regionId)
                .setInstanceId(instanceId);
        if (!com.aliyun.teautil.Common.isUnset(timeToRelease)) {
            req.autoReleaseTime = timeToRelease;
        }

        client.modifyInstanceAutoReleaseTime(req);
        String releaseTime = Sample.CheckAutoReleaseTimeReady(client, regionId, instanceId);
        com.aliyun.teaconsole.Client.log("Check instance " + instanceId + " auto release time setting is " + releaseTime + ".");
    }

    public static void main(String[] args_) throws Exception {
        java.util.List<String> args = java.util.Arrays.asList(args_);
        // 区域ID
        String regionId = args.get(0);
        // 实例ID
        String instanceId = args.get(1);
        com.aliyun.ecs20140526.Client client = Sample.Initialization(regionId);
        Sample.StopInstance(client, instanceId, false);
        // SetInstanceAutoReleaseTime(client, regionId, instanceId, "2024-10-01T06:00:00Z");
        // SetInstanceAutoReleaseTime(client, regionId, instanceId, null);
        Sample.ReleaseInstance(client, regionId, instanceId, false);
        // ReleaseInstance(client, regionId, instanceId, true);
    }
}
